Index: branches/r9/apps/Makefile.in
===================================================================
--- branches/r9/apps/Makefile.in	(revision 4913)
+++ branches/r9/apps/Makefile.in	(revision 4914)
@@ -24,4 +24,5 @@
 		copy_rappture_examples \
 		encodedata \
+		$(srcdir)/execute.tcl \
 		$(srcdir)/launcher.tcl \
 		$(srcdir)/mapviewer-test \
Index: branches/r9/configure.in
===================================================================
--- branches/r9/configure.in	(revision 4913)
+++ branches/r9/configure.in	(revision 4914)
@@ -315,5 +315,5 @@
 AC_SUBST(RAPPTURE_MINOR_VERSION)
 AC_SUBST(RAPPTURE_RELEASE_SERIAL)
-
+AC_SUBST(RAPPTURE_VERSION)
 AC_SUBST(WITH_VTK)
 AC_SUBST(WITH_R)
Index: branches/r9/gui/Makefile.in
===================================================================
--- branches/r9/gui/Makefile.in	(revision 4913)
+++ branches/r9/gui/Makefile.in	(revision 4914)
@@ -14,5 +14,5 @@
 MKDIR_P		= @MKDIR_P@
 VPATH		= $(srcdir)
-TCLSH		= @TCLSH@
+TCLSH		= ${bindir}/tclsh
 
 PACKAGE_VERSION = @PACKAGE_VERSION@
Index: branches/r9/gui/configure.in
===================================================================
--- branches/r9/gui/configure.in	(revision 4913)
+++ branches/r9/gui/configure.in	(revision 4914)
@@ -14,19 +14,13 @@
 fi
 
+if test -r ${exec_prefix}/lib/rapptureConfig.sh; then
+  . ${exec_prefix}/lib/rapptureConfig.sh
+  PACKAGE_VERSION=$RAPPTURE_VERSION
+fi    
+
 AC_PROG_INSTALL
 AC_PROG_LN_S
 AC_PROG_MKDIR_P
 AC_PROG_MAKE_SET
-
-if test -f "${exec_prefix}/lib/tclConfig.sh" ; then 
-  . ${exec_prefix}/lib/tclConfig.sh
-fi
-if test -f "${exec_prefix}/lib/tkConfig.sh" ; then 
-  . ${exec_prefix}/lib/tkConfig.sh	
-fi
-
-TCLSH=${bindir}/tclsh${TCL_VERSION}
-AC_MSG_RESULT([${TCLSH}])
-AC_SUBST(TCLSH)
 
 AC_CONFIG_FILES([
Index: branches/r9/gui/scripts/Makefile.in
===================================================================
--- branches/r9/gui/scripts/Makefile.in	(revision 4913)
+++ branches/r9/gui/scripts/Makefile.in	(revision 4914)
@@ -14,5 +14,5 @@
 INSTALL		= @INSTALL@
 MKDIR_P		= @MKDIR_P@
-TCLSH		= @TCLSH@
+TCLSH		= ${bindir}/tclsh
 VPATH		= $(srcdir)
 PACKAGE_VERSION = @PACKAGE_VERSION@
Index: branches/r9/lang/configure
===================================================================
--- branches/r9/lang/configure	(revision 4913)
+++ branches/r9/lang/configure	(revision 4914)
@@ -629,8 +629,10 @@
 TCL_SHLIB_LD
 TCL_SHLIB_CFLAGS
+TCL_LIB_SPEC
+TCL_INC_SPEC
 TCL_CFLAGS_OPTIMIZE
 TCL_CFLAGS_DEBUG
-TCL_LIB_SPEC
-TCL_INC_SPEC
+TCLSH
+SVN_VERSION
 SIZEOF_VOID_P
 SIZEOF_LONG_LONG
@@ -641,4 +643,8 @@
 RUBY_PLATFORM
 RP_BASE
+RAPPTURE_VERSION
+RAPPTURE_RELEASE_SERIAL
+RAPPTURE_MINOR_VERSION
+RAPPTURE_MAJOR_VERSION
 PYTHON_VERSION
 PYTHON_SITE_PACKAGES
@@ -664,5 +670,4 @@
 OCTAVE_VERSION_MAJOR
 OCTAVE_VERSION
-SVN_VERSION
 MKOCTFILE3
 MKOCTFILE2
@@ -712,5 +717,4 @@
 MEX
 MATLAB
-TCLSH
 INSTALL_STUB_LIB
 INSTALL_LIB
@@ -808,5 +812,4 @@
 enable_corefoundation
 enable_load
-with_tclsh
 with_matlab
 with_octave
@@ -1467,5 +1470,4 @@
   --with-x                use the X Window System
   --with-install=DIR      location of installation [default=yes]
-  --with-tclsh=DIR        location of tclsh [default=yes]
   --with-matlab=DIR       location of matlab and mex compiler [default=yes]
   --with-octave=DIR       path of default octave compiler `mkoctfile'
@@ -7460,129 +7462,12 @@
 
 
-SVN_VERSION=`svnversion $srcdir`
-
-make_command=""
-for m in "$MAKE" make gmake gnumake ; do
-  if test "x${m}" != "x" ; then
-    if  ( sh -c "$m --version" 2>/dev/null | grep GNU >/dev/null ) ; then
-      make_command=$m; break;
-    fi
-  fi
-done
-if test "x${make_command}" = "x" ; then
-  as_fn_error $? "Requires GNU make. You can specify a version with \$MAKE" "$LINENO" 5
-fi
-
-TCL_VERSION="8.4"
-for dir in \
- ${exec_prefix} \
- ${exec_prefix}/lib ; do
-  tclconfig="${dir}/tclConfig.sh"
-  if test -f "$tclconfig" ; then
-    . $tclconfig
-    break
-  fi
-done
-
-
-# Check whether --with-tclsh was given.
-if test "${with_tclsh+set}" = set; then :
-  withval=$with_tclsh;
-else
-  with_tclsh=yes
-fi
-
-
-TCLSH=""
-if test "${with_tclsh}" != "no" ; then
-  tclsh="tclsh${TCL_VERSION}"
-  if test "${with_tclsh}" = "yes" ; then
-    # Extract the first word of "${tclsh}", so it can be a program name with args.
-set dummy ${tclsh}; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if ${ac_cv_path_TCLSH+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  case $TCLSH in
-  [\\/]* | ?:[\\/]*)
-  ac_cv_path_TCLSH="$TCLSH" # Let the user override the test with a path.
-  ;;
-  *)
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-as_dummy="${exec_prefix}/bin:${PATH}"
-for as_dir in $as_dummy
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
-    ac_cv_path_TCLSH="$as_dir/$ac_word$ac_exec_ext"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-  ;;
-esac
-fi
-TCLSH=$ac_cv_path_TCLSH
-if test -n "$TCLSH"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $TCLSH" >&5
-$as_echo "$TCLSH" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-  else
-    # Extract the first word of "${tclsh}", so it can be a program name with args.
-set dummy ${tclsh}; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if ${ac_cv_path_TCLSH+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  case $TCLSH in
-  [\\/]* | ?:[\\/]*)
-  ac_cv_path_TCLSH="$TCLSH" # Let the user override the test with a path.
-  ;;
-  *)
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-as_dummy="${with_tclsh}/bin:${with_tclsh}"
-for as_dir in $as_dummy
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
-    ac_cv_path_TCLSH="$as_dir/$ac_word$ac_exec_ext"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-  ;;
-esac
-fi
-TCLSH=$ac_cv_path_TCLSH
-if test -n "$TCLSH"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $TCLSH" >&5
-$as_echo "$TCLSH" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-  fi
-  if test "x${TCLSH}" = "x" ; then
-    as_fn_error $? "can't find tclsh" "$LINENO" 5
-  fi
+if test -r "${exec_prefix}/lib/tclConfig.sh" ; then
+  . ${exec_prefix}/lib/tclConfig.sh
+fi
+if test -r "${exec_prefix}/lib/tkConfig.sh" ; then
+  . ${exec_prefix}/lib/tkConfig.sh
+fi
+if test -r "${exec_prefix}/lib/rapptureConfig.sh" ; then
+  . ${exec_prefix}/lib/rapptureConfig.sh
 fi
 
@@ -9669,4 +9554,8 @@
 
 MAKE=${make_command}
+
+
+
+
 
 
Index: branches/r9/lang/configure.in
===================================================================
--- branches/r9/lang/configure.in	(revision 4913)
+++ branches/r9/lang/configure.in	(revision 4914)
@@ -99,47 +99,12 @@
 SC_CONFIG_CFLAGS
 
-SVN_VERSION=`svnversion $srcdir`
-
-make_command=""
-for m in "$MAKE" make gmake gnumake ; do
-  if test "x${m}" != "x" ; then
-    if  ( sh -c "$m --version" 2>/dev/null | grep GNU >/dev/null ) ; then
-      make_command=$m; break;
-    fi
-  fi
-done
-if test "x${make_command}" = "x" ; then
-  AC_MSG_ERROR([Requires GNU make. You can specify a version with \$MAKE])
-fi
-
-TCL_VERSION="8.4"
-for dir in \
- ${exec_prefix} \
- ${exec_prefix}/lib ; do 
-  tclconfig="${dir}/tclConfig.sh"
-  if test -f "$tclconfig" ; then
-    . $tclconfig
-    break
-  fi
-done
-
-AC_ARG_WITH(
-    [tclsh],
-    [AS_HELP_STRING([--with-tclsh[=DIR]],
-        [location of tclsh @<:@default=yes@:>@])],
-    [],
-    [with_tclsh=yes])
-
-TCLSH=""
-if test "${with_tclsh}" != "no" ; then
-  tclsh="tclsh${TCL_VERSION}"
-  if test "${with_tclsh}" = "yes" ; then 
-    AC_PATH_PROG(TCLSH, ${tclsh}, [], [${exec_prefix}/bin:${PATH}])
-  else 
-    AC_PATH_PROG(TCLSH, ${tclsh}, [], [${with_tclsh}/bin:${with_tclsh}])
-  fi
-  if test "x${TCLSH}" = "x" ; then
-    AC_ERROR([can't find tclsh])
-  fi
+if test -r "${exec_prefix}/lib/tclConfig.sh" ; then
+  . ${exec_prefix}/lib/tclConfig.sh
+fi   
+if test -r "${exec_prefix}/lib/tkConfig.sh" ; then
+  . ${exec_prefix}/lib/tkConfig.sh
+fi
+if test -r "${exec_prefix}/lib/rapptureConfig.sh" ; then
+  . ${exec_prefix}/lib/rapptureConfig.sh
 fi
 
@@ -213,5 +178,4 @@
 AC_SUBST(MKOCTFILE2)
 AC_SUBST(MKOCTFILE3)
-AC_SUBST(SVN_VERSION)
 AC_SUBST(OCTAVE_VERSION)
 AC_SUBST(OCTAVE_VERSION_MAJOR)
@@ -240,4 +204,8 @@
 AC_SUBST(PYTHON_VERSION)
 AC_SUBST(R)
+AC_SUBST(RAPPTURE_MAJOR_VERSION)
+AC_SUBST(RAPPTURE_MINOR_VERSION)
+AC_SUBST(RAPPTURE_RELEASE_SERIAL)
+AC_SUBST(RAPPTURE_VERSION)
 AC_SUBST(RP_BASE)
 AC_SUBST(RUBY)
@@ -253,20 +221,21 @@
 AC_SUBST(SIZEOF_VOID_P)
 AC_SUBST(STLIB_LD)
+AC_SUBST(SVN_VERSION)
 AC_SUBST(TCLSH)
+AC_SUBST(TCL_CFLAGS_DEBUG)
+AC_SUBST(TCL_CFLAGS_DEBUG)
+AC_SUBST(TCL_CFLAGS_OPTIMIZE)
 AC_SUBST(TCL_INC_SPEC)
 AC_SUBST(TCL_LIB_SPEC)
-AC_SUBST(TCL_CFLAGS_DEBUG)
-AC_SUBST(TCL_CFLAGS_OPTIMIZE)
+AC_SUBST(TCL_SHLIB_CFLAGS)
 AC_SUBST(TCL_SHLIB_CFLAGS)
 AC_SUBST(TCL_SHLIB_LD)
+AC_SUBST(TCL_SHLIB_LD)
 AC_SUBST(TCL_SHLIB_LDFLAGS)
+AC_SUBST(TCL_SHLIB_LDFLAGS)
+AC_SUBST(TCL_SHLIB_SUFFIX)
 AC_SUBST(TCL_SHLIB_SUFFIX)
 AC_SUBST(TCL_VERSION)
 AC_SUBST(TCL_VERSION)
-AC_SUBST(TCL_CFLAGS_DEBUG)
-AC_SUBST(TCL_SHLIB_CFLAGS)
-AC_SUBST(TCL_SHLIB_SUFFIX)
-AC_SUBST(TCL_SHLIB_LD)
-AC_SUBST(TCL_SHLIB_LDFLAGS)
 AC_SUBST(XSUBPP)
 
Index: branches/r9/lang/tcl/Makefile.in
===================================================================
--- branches/r9/lang/tcl/Makefile.in	(revision 4913)
+++ branches/r9/lang/tcl/Makefile.in	(revision 4914)
@@ -9,30 +9,25 @@
 prefix          = @prefix@
 
-destdir         = $(libdir)/Rappture$(PACKAGE_VERSION)
+destdir         = $(libdir)/Rappture$(VERSION)
 
-PACKAGE_VERSION = @PACKAGE_VERSION@
-
+AR              = ar
+CC              = @CC@
+CFLAGS          = @CFLAGS@
+CFLAGS_DEBUG    = @CFLAGS_DEBUG@
+CFLAGS_DEFAULT  = @CFLAGS_DEFAULT@
+CFLAGS_OPTIMIZE = @CFLAGS_OPTIMIZE@
+CXX             = @CXX@
 INSTALL         = @INSTALL@
-
-CXX             = @CXX@
-CC              = @CC@
-CFLAGS_DEBUG    = @CFLAGS_DEBUG@
-CFLAGS_OPTIMIZE = @CFLAGS_OPTIMIZE@
-STLIB_LD        = @STLIB_LD@
+LIB_SEARCH_DIRS = @LIB_SEARCH_DIRS@
+LN_S            = @LN_S@
+MKDIR_P         = @MKDIR_P@
+RANLIB          = @RANLIB@
+VERSION		= @RAPPTURE_VERSION@
+RM              = rm -f
+SHLIB_CFLAGS    = @SHLIB_CFLAGS@
 SHLIB_LD        = @SHLIB_LD@
-SHLIB_CFLAGS    = @SHLIB_CFLAGS@
 SHLIB_LDFLAGS   = @SHLIB_LDFLAGS@
 SHLIB_SUFFIX    = @SHLIB_SUFFIX@
-CFLAGS_DEFAULT  = @CFLAGS_DEFAULT@
-LIB_SEARCH_DIRS = @LIB_SEARCH_DIRS@
-CFLAGS          = @CFLAGS@
-TCL_VERSION     = @TCL_VERSION@
-TK_VERSION      = @TK_VERSION@
-
-RANLIB          = @RANLIB@
-MKDIR_P         = @MKDIR_P@
-AR              = ar
-LN_S            = @LN_S@
-RM              = rm -f
+STLIB_LD        = @STLIB_LD@
 
 # The script directory is moved from src/tcl.
@@ -51,8 +46,4 @@
 	$(MAKE) -C src install
 	$(MAKE) -C scripts install
-	$(RM) $(bindir)/tclsh
-	(cd $(bindir); $(LN_S) tclsh$(TCL_VERSION) tclsh)
-	$(RM) $(bindir)/wish
-	(cd $(bindir); $(LN_S) wish$(TK_VERSION) wish)
 
 test:
Index: branches/r9/lang/tcl/pkgIndex.tcl.in
===================================================================
--- branches/r9/lang/tcl/pkgIndex.tcl.in	(revision 4913)
+++ branches/r9/lang/tcl/pkgIndex.tcl.in	(revision 4914)
@@ -1,6 +1,6 @@
 # This is a duplicate of pkgs/runner/pkgIndex.tcl.in
-package ifneeded Rappture @PACKAGE_VERSION@ [format {
+package ifneeded Rappture @RAPPTURE_VERSION@ [format {
     set dir "%s"
-    set version @PACKAGE_VERSION@
+    set version @RAPPTURE_VERSION@
     lappend auto_path [file join $dir scripts]
     namespace eval Rappture {
Index: branches/r9/lang/tcl/scripts/Makefile.in
===================================================================
--- branches/r9/lang/tcl/scripts/Makefile.in	(revision 4913)
+++ branches/r9/lang/tcl/scripts/Makefile.in	(revision 4914)
@@ -10,29 +10,27 @@
 srcdir          = @srcdir@
 
+AR 		= ar
+CC              = @CC@
+CFLAGS          = @CFLAGS@
+CFLAGS_DEBUG    = @CFLAGS_DEBUG@
+CFLAGS_DEFAULT  = @CFLAGS_DEFAULT@
+CFLAGS_OPTIMIZE = @CFLAGS_OPTIMIZE@
+CXX             = @CXX@
 INSTALL		= @INSTALL@
+INSTALL_DATA	= ${INSTALL} -m 644
 INSTALL_PROGRAM	= ${INSTALL} -m 755
-INSTALL_DATA	= ${INSTALL} -m 644
 INSTALL_SCRIPT	= ${INSTALL}
-TCL_VERSION     = @TCL_VERSION@
-TCLSH		= $(bindir)/tclsh$(TCL_VERSION)
-VERSION		= @PACKAGE_VERSION@
-VPATH		= $(srcdir)
-
-CXX             = @CXX@
-CC              = @CC@
-CFLAGS_DEBUG    = @CFLAGS_DEBUG@
-CFLAGS_OPTIMIZE = @CFLAGS_OPTIMIZE@
+LIB_SEARCH_DIRS = @LIB_SEARCH_DIRS@
+MKDIR_P		= @MKDIR_P@
+RANLIB 		= @RANLIB@
+RM		= rm -f
+SHLIB_CFLAGS    = @SHLIB_CFLAGS@
 SHLIB_LD        = @SHLIB_LD@
-SHLIB_CFLAGS    = @SHLIB_CFLAGS@
 SHLIB_LDFLAGS   = @SHLIB_LDFLAGS@
 SHLIB_SUFFIX    = @SHLIB_SUFFIX@
-CFLAGS_DEFAULT  = @CFLAGS_DEFAULT@
-LIB_SEARCH_DIRS = @LIB_SEARCH_DIRS@
-CFLAGS          = @CFLAGS@
-
-RANLIB 		= @RANLIB@
-MKDIR_P		= @MKDIR_P@
-AR 		= ar
-RM		= rm -f
+TCLSH		= $(bindir)/tclsh$(TCL_VERSION)
+TCL_VERSION     = @TCL_VERSION@
+VERSION		= @RAPPTURE_VERSION@
+VPATH		= $(srcdir)
 
 destdir		= $(prefix)/lib/Rappture$(VERSION)/scripts
Index: branches/r9/lang/tcl/src/Makefile.in
===================================================================
--- branches/r9/lang/tcl/src/Makefile.in	(revision 4913)
+++ branches/r9/lang/tcl/src/Makefile.in	(revision 4914)
@@ -10,22 +10,22 @@
 srcdir          = @srcdir@
 
+CC              = @CC@
+CFLAGS          = @CFLAGS@ -fPIC
+CFLAGS_DEBUG    = @CFLAGS_DEBUG@ -Wall
+CFLAGS_DEFAULT  = @CFLAGS_DEFAULT@
+CFLAGS_OPTIMIZE = @CFLAGS_OPTIMIZE@
+CXX             = @CXX@
+INSTALL         = @INSTALL@
+LIB_SEARCH_DIRS = @LIB_SEARCH_DIRS@
+MKDIR_P         = @MKDIR_P@
 SHELL           = @SHELL@
-INSTALL         = @INSTALL@
-MKDIR_P         = @MKDIR_P@
-
-CXX             = @CXX@
-CC              = @CC@
-CFLAGS_DEBUG    = @CFLAGS_DEBUG@ -Wall
-CFLAGS_OPTIMIZE = @CFLAGS_OPTIMIZE@
-STLIB_LD        = @STLIB_LD@
+SHLIB_CFLAGS    = @SHLIB_CFLAGS@
 SHLIB_LD        = @SHLIB_LD@
-SHLIB_CFLAGS    = @SHLIB_CFLAGS@
 SHLIB_LDFLAGS   = @SHLIB_LDFLAGS@
 SHLIB_SUFFIX    = @SHLIB_SUFFIX@
-CFLAGS_DEFAULT  = @CFLAGS_DEFAULT@
-LIB_SEARCH_DIRS = @LIB_SEARCH_DIRS@
-CFLAGS          = @CFLAGS@ -fPIC
-TCL_VERSION     = @TCL_VERSION@
+STLIB_LD        = @STLIB_LD@
+SVN_VERSION     = @SVN_VERSION@
 TCL_LIB_SPEC    = @TCL_LIB_SPEC@
+VERSION		= @RAPPTURE_VERSION@
 
 CC_SWITCHES     = $(CFLAGS) $(CFLAGS_DEBUG) $(INCLUDES) $(DEFINES)
@@ -35,8 +35,6 @@
 		  -I$(includedir) 
 
-RAPPTURE_VERSION = @PACKAGE_VERSION@
-SVN_VERSION     := $(shell svnversion $(srcdir))
 DEFINES         = -DSVN_VERSION=\"$(SVN_VERSION)\" \
-                  -DRAPPTURE_VERSION=\"$(RAPPTURE_VERSION)\"
+                  -DRAPPTURE_VERSION=\"$(VERSION)\"
 
 RANLIB          = @RANLIB@
@@ -60,5 +58,5 @@
 # Not using     RpLibraryTclInterface.o \
 
-name        = Rappture$(RAPPTURE_VERSION)
+name        = Rappture$(VERSION)
 libname     = $(name)
 lib         = $(libname)$(SHLIB_SUFFIX)
Index: branches/r9/pkgs/DxToVtk/Makefile.in
===================================================================
--- branches/r9/pkgs/DxToVtk/Makefile.in	(revision 4913)
+++ branches/r9/pkgs/DxToVtk/Makefile.in	(revision 4914)
@@ -74,4 +74,5 @@
 TCL_LIB_SPEC    = @TCL_LIB_SPEC@
 TK_LIB_SPEC     = @TK_LIB_SPEC@
+VERSION		= @RAPPTURE_VERSION@
 
 CC_SWITCHES     = $(CFLAGS) $(CFLAGS_DEBUG) $(INCLUDES) $(DEFINES)
@@ -85,6 +86,5 @@
 	        $(TCL_LIB_SPEC) 
 
-version =	@RAPPTURE_VERSION@
-DEFINES =	-DRAPPTURE_VERSION=\"$(version)\"
+DEFINES =	-DRAPPTURE_VERSION=\"$(VERSION)\"
 
 RANLIB =	@RANLIB@
@@ -98,5 +98,5 @@
 		RpDxToVtk.o 
 
-name        = RapptureDxToVtk$(version)
+name        = RapptureDxToVtk$(VERSION)
 libname     = $(name)
 lib         = $(libname)$(SHLIB_SUFFIX)
@@ -127,44 +127,2 @@
 	$(RM) Makefile pkgIndex.tcl *~
 
-ES =	-DRAPPTURE_VERSION=\"$(version)\"
-
-RANLIB =	@RANLIB@
-AR =		ar
-VPATH =		$(srcdir)
-RM =		rm -f
-
-CDEBUGFLAGS =	-g -Wall
-
-
-OBJS =		\
-		RpDxToVtk.o 
-
-name        = RapptureDxToVtk$(version)
-libname     = $(name)
-lib         = $(libname)$(SHLIB_SUFFIX)
-destdir     = $(libdir)/$(name)
-
-.PHONY: all install clean distclean
-
-all: $(lib)
-
-$(lib): $(OBJS)
-	$(SHLIB_LD) $(SHLIB_LDFLAGS) -o $@ $(OBJS) \
-		$(LIB_SEARCH_DIRS) $(LIBS)
-
-install: $(lib)
-	$(MKDIR_P) -m 0755 $(destdir)
-	$(INSTALL) -m 0555 $(lib) $(destdir)
-	$(INSTALL) -m 0444 pkgIndex.tcl $(destdir)
-
-.cpp.o:
-	$(CXX) $(CXX_SWITCHES) -c $?
-.c.o:
-	$(CC) $(CC_SWITCHES) -c $?
-
-clean:
-	$(RM) $(OBJS) $(lib)
-
-distclean: clean
-	$(RM) Makefile pkgIndex.tcl *~
-
Index: branches/r9/pkgs/Makefile.in
===================================================================
--- branches/r9/pkgs/Makefile.in	(revision 4913)
+++ branches/r9/pkgs/Makefile.in	(revision 4914)
@@ -26,4 +26,5 @@
 		placard \
 		readpoints \
+		runner \
 		squeezer \
 		system 
Index: branches/r9/pkgs/placard/Makefile.in
===================================================================
--- branches/r9/pkgs/placard/Makefile.in	(revision 4913)
+++ branches/r9/pkgs/placard/Makefile.in	(revision 4914)
@@ -23,5 +23,4 @@
 MKDIR_P         = @MKDIR_P@
 RANLIB		= @RANLIB@
-RAPPTURE_VERSION= @RAPPTURE_VERSION@
 RM		= rm -f
 SHELL           = @SHELL@
@@ -33,4 +32,5 @@
 TCL_LIB_SPEC    = @TCL_LIB_SPEC@
 TK_LIB_SPEC     = @TK_LIB_SPEC@
+VERSION		= @RAPPTURE_VERSION@
 VPATH		= $(srcdir)
 
@@ -46,5 +46,5 @@
 		$(TK_LIB_SPEC) 
 
-DEFINES =	-DRAPPTURE_VERSION=\"$(RAPPTURE_VERSION)\"
+DEFINES =	-DRAPPTURE_VERSION=\"$(VERSION)\"
 
 CDEBUGFLAGS =	-g -Wall
@@ -52,5 +52,5 @@
 OBJS		= placard.o 
 
-name		= RapptureCanvasPlacard$(version)
+name		= RapptureCanvasPlacard$(VERSION)
 libname		= $(name)
 lib		= $(libname)$(SHLIB_SUFFIX)
Index: branches/r9/pkgs/readpoints/Makefile.in
===================================================================
--- branches/r9/pkgs/readpoints/Makefile.in	(revision 4913)
+++ branches/r9/pkgs/readpoints/Makefile.in	(revision 4914)
@@ -22,5 +22,5 @@
 MKDIR_P         = @MKDIR_P@
 RANLIB		= @RANLIB@
-RAPPTURE_VERSION= @RAPPTURE_VERSION@
+VERSION		= @RAPPTURE_VERSION@
 RM		= rm -f
 SHELL           = @SHELL@
@@ -44,5 +44,5 @@
 		$(TK_LIB_SPEC) 
 
-DEFINES =	-DRAPPTURE_VERSION=\"$(RAPPTURE_VERSION)\"
+DEFINES =	-DRAPPTURE_VERSION=\"$(VERSION)\"
 
 CDEBUGFLAGS =	-g -Wall
@@ -51,5 +51,5 @@
 		readPoints.o 
 
-name        = RapptureReadPoints$(version)
+name        = RapptureReadPoints$(VERSION)
 libname     = $(name)
 lib         = $(libname)$(SHLIB_SUFFIX)
Index: branches/r9/pkgs/runner/Makefile.in
===================================================================
--- branches/r9/pkgs/runner/Makefile.in	(revision 4913)
+++ branches/r9/pkgs/runner/Makefile.in	(revision 4914)
@@ -10,5 +10,5 @@
 srcdir          = @srcdir@
 
-destdir         = $(libdir)/Rappture$(RAPPTURE_VERSION)
+destdir         = $(libdir)/Rappture$(VERSION)
 
 AR              = ar
@@ -24,5 +24,4 @@
 MKDIR_P         = @MKDIR_P@
 RANLIB          = @RANLIB@
-RAPPTURE_VERSION = @RAPPTURE_VERSION@
 RM              = rm -f
 SHLIB_CFLAGS    = @SHLIB_CFLAGS@
@@ -31,4 +30,5 @@
 SHLIB_SUFFIX    = @SHLIB_SUFFIX@
 STLIB_LD        = @STLIB_LD@
+VERSION		= @RAPPTURE_VERSION@
 
 XMLFILES	= \
@@ -37,5 +37,5 @@
 .PHONY: src scripts 
 
-hall:
+all:
 	$(MAKE) -C scripts all
 
Index: branches/r9/pkgs/runner/pkgIndex.tcl.in
===================================================================
--- branches/r9/pkgs/runner/pkgIndex.tcl.in	(revision 4913)
+++ branches/r9/pkgs/runner/pkgIndex.tcl.in	(revision 4914)
@@ -1,6 +1,6 @@
 # This is a duplicate of lang/tcl/pkgIndex.tcl.in
-package ifneeded Rappture @PACKAGE_VERSION@ [format {
+package ifneeded Rappture @RAPPTURE_VERSION@ [format {
     set dir "%s"
-    set version @PACKAGE_VERSION@
+    set version @RAPPTURE_VERSION@
     lappend auto_path [file join $dir scripts]
     namespace eval Rappture {