Index: branches/r9/Makefile.in
===================================================================
--- branches/r9/Makefile.in	(revision 4914)
+++ branches/r9/Makefile.in	(revision 4915)
@@ -868,4 +868,6 @@
 define install_lib
 	$(MAKE) -C $(lib) install
+	$(MKDIR_P) $(libdir)
+	$(INSTALL) -m 0444 rapptureConfig.sh $(libdir)
 endef
 define touch_lib
Index: branches/r9/configure
===================================================================
--- branches/r9/configure	(revision 4914)
+++ branches/r9/configure	(revision 4915)
@@ -636,4 +636,5 @@
 WITH_R
 WITH_VTK
+RAPPTURE_VERSION
 RAPPTURE_RELEASE_SERIAL
 RAPPTURE_MINOR_VERSION
@@ -8078,5 +8079,5 @@
 
 
-ac_config_files="$ac_config_files Makefile fixrunpaths.tcl apps/Makefile apps/about apps/copy_rappture_examples apps/encodedata apps/rappture apps/rappture-csh.env apps/rappture.env apps/rappture.use apps/rerun apps/simsim apps/xmldiff lib/Makefile lib/objects/Makefile lib/objects/RpHash.h lib/rappture/Makefile lib/rappture2/Makefile lib/rapptureConfig.sh pkgs/DicomToVtk/Makefile pkgs/DicomToVtk/pkgIndex.tcl pkgs/DxToVtk/Makefile pkgs/DxToVtk/pkgIndex.tcl pkgs/Makefile pkgs/PdbToVtk/Makefile pkgs/PdbToVtk/pkgIndex.tcl pkgs/builder/Makefile pkgs/builder/pkgIndex.tcl pkgs/builder/scripts/Makefile pkgs/diffview/Makefile pkgs/diffview/pkgIndex.tcl pkgs/hotspot/Makefile pkgs/hotspot/pkgIndex.tcl pkgs/listbox/Makefile pkgs/listbox/pkgIndex.tcl pkgs/objects/Makefile pkgs/p2p/Makefile pkgs/placard/Makefile pkgs/placard/pkgIndex.tcl pkgs/readpoints/Makefile pkgs/readpoints/pkgIndex.tcl pkgs/runner/Makefile pkgs/runner/pkgIndex.tcl pkgs/runner/scripts/Makefile pkgs/squeezer/Makefile pkgs/squeezer/pkgIndex.tcl pkgs/system/Makefile pkgs/system/pkgIndex.tcl pkgs/tester/Makefile pkgs/tester/pkgIndex.tcl pkgs/tester/scripts/Makefile"
+ac_config_files="$ac_config_files Makefile fixrunpaths.tcl apps/Makefile apps/about apps/copy_rappture_examples apps/encodedata apps/rappture apps/rappture-csh.env apps/rappture.env apps/rappture.use apps/rerun apps/simsim apps/xmldiff lib/Makefile lib/objects/Makefile lib/objects/RpHash.h lib/rappture/Makefile lib/rappture2/Makefile rapptureConfig.sh"
 
 cat >confcache <<\_ACEOF
@@ -8791,37 +8792,5 @@
     "lib/rappture/Makefile") CONFIG_FILES="$CONFIG_FILES lib/rappture/Makefile" ;;
     "lib/rappture2/Makefile") CONFIG_FILES="$CONFIG_FILES lib/rappture2/Makefile" ;;
-    "lib/rapptureConfig.sh") CONFIG_FILES="$CONFIG_FILES lib/rapptureConfig.sh" ;;
-    "pkgs/DicomToVtk/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/DicomToVtk/Makefile" ;;
-    "pkgs/DicomToVtk/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/DicomToVtk/pkgIndex.tcl" ;;
-    "pkgs/DxToVtk/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/DxToVtk/Makefile" ;;
-    "pkgs/DxToVtk/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/DxToVtk/pkgIndex.tcl" ;;
-    "pkgs/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/Makefile" ;;
-    "pkgs/PdbToVtk/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/PdbToVtk/Makefile" ;;
-    "pkgs/PdbToVtk/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/PdbToVtk/pkgIndex.tcl" ;;
-    "pkgs/builder/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/builder/Makefile" ;;
-    "pkgs/builder/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/builder/pkgIndex.tcl" ;;
-    "pkgs/builder/scripts/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/builder/scripts/Makefile" ;;
-    "pkgs/diffview/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/diffview/Makefile" ;;
-    "pkgs/diffview/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/diffview/pkgIndex.tcl" ;;
-    "pkgs/hotspot/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/hotspot/Makefile" ;;
-    "pkgs/hotspot/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/hotspot/pkgIndex.tcl" ;;
-    "pkgs/listbox/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/listbox/Makefile" ;;
-    "pkgs/listbox/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/listbox/pkgIndex.tcl" ;;
-    "pkgs/objects/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/objects/Makefile" ;;
-    "pkgs/p2p/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/p2p/Makefile" ;;
-    "pkgs/placard/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/placard/Makefile" ;;
-    "pkgs/placard/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/placard/pkgIndex.tcl" ;;
-    "pkgs/readpoints/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/readpoints/Makefile" ;;
-    "pkgs/readpoints/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/readpoints/pkgIndex.tcl" ;;
-    "pkgs/runner/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/runner/Makefile" ;;
-    "pkgs/runner/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/runner/pkgIndex.tcl" ;;
-    "pkgs/runner/scripts/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/runner/scripts/Makefile" ;;
-    "pkgs/squeezer/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/squeezer/Makefile" ;;
-    "pkgs/squeezer/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/squeezer/pkgIndex.tcl" ;;
-    "pkgs/system/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/system/Makefile" ;;
-    "pkgs/system/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/system/pkgIndex.tcl" ;;
-    "pkgs/tester/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/tester/Makefile" ;;
-    "pkgs/tester/pkgIndex.tcl") CONFIG_FILES="$CONFIG_FILES pkgs/tester/pkgIndex.tcl" ;;
-    "pkgs/tester/scripts/Makefile") CONFIG_FILES="$CONFIG_FILES pkgs/tester/scripts/Makefile" ;;
+    "rapptureConfig.sh") CONFIG_FILES="$CONFIG_FILES rapptureConfig.sh" ;;
 
   *) as_fn_error $? "invalid argument: \`$ac_config_target'" "$LINENO" 5;;
Index: branches/r9/configure.in
===================================================================
--- branches/r9/configure.in	(revision 4914)
+++ branches/r9/configure.in	(revision 4915)
@@ -350,5 +350,5 @@
     lib/rappture/Makefile
     lib/rappture2/Makefile
-    lib/rapptureConfig.sh
+    rapptureConfig.sh
 ])
 AC_OUTPUT
Index: branches/r9/lib/Makefile.in
===================================================================
--- branches/r9/lib/Makefile.in	(revision 4914)
+++ branches/r9/lib/Makefile.in	(revision 4915)
@@ -45,5 +45,4 @@
 	  $(MAKE) -C $$i install || exit 1 ;\
 	done
-	$(INSTALL) -m 0444 rapptureConfig.sh $(libdir)
 
 docs:
Index: branches/r9/lib/rapptureConfig.sh.in
===================================================================
--- branches/r9/lib/rapptureConfig.sh.in	(revision 4914)
+++ 	(revision )
@@ -1,30 +1,0 @@
-# rapptureConfig.sh --
-# 
-# This shell script (for sh) is generated automatically by Rappture's
-# configure script.  It will create shell variables for most of
-# the configuration options discovered by the configure script.
-# This script is intended to be included by the configure scripts
-# for Tcl extensions so that they don't have to figure this all
-# out for themselves.
-#
-# The information in this file is specific to a single platform.
-
-RAPPTURE_MAJOR_VERSION=@RAPPTURE_MAJOR_VERSION@
-RAPPTURE_MINOR_VERSION=@RAPPTURE_MINOR_VERSION@
-RAPPTURE_RELEASE_SERIAL=@RAPPTURE_RELEASE_SERIAL@
-RAPPTURE_VERSION="${RAPPTURE_MAJOR_VERSION}.${RAPPTURE_MINOR_VERSION}"
-SVN_VERSION="@SVN_VERSION@"
-
-WITH_R=@WITH_R@
-WITH_JAVA=@WITH_JAVA@
-WITH_MATLAB=@WITH_MATLAB@
-WITH_MKOCTFILE2=@WITH_MKOCTFILE2@
-WITH_MKOCTFILE3=@WITH_MKOCTFILE3@
-WITH_OCTAVE=@WITH_OCTAVE@
-WITH_PERL=@WITH_PERL@
-WITH_PYTHON=@WITH_PYTHON@
-WITH_RUBY=@WITH_RUBY@
-WITH_RUBY_SITELIBDIR=@WITH_RUBY_SITELIBDIR@
-WITH_TCL=@WITH_TCL@
-WITH_VTK=@WITH_VTK@
-
Index: branches/r9/rapptureConfig.sh.in
===================================================================
--- branches/r9/rapptureConfig.sh.in	(revision 4915)
+++ branches/r9/rapptureConfig.sh.in	(revision 4915)
@@ -0,0 +1,30 @@
+# rapptureConfig.sh --
+# 
+# This shell script (for sh) is generated automatically by Rappture's
+# configure script.  It will create shell variables for most of
+# the configuration options discovered by the configure script.
+# This script is intended to be included by the configure scripts
+# for Tcl extensions so that they don't have to figure this all
+# out for themselves.
+#
+# The information in this file is specific to a single platform.
+
+RAPPTURE_MAJOR_VERSION=@RAPPTURE_MAJOR_VERSION@
+RAPPTURE_MINOR_VERSION=@RAPPTURE_MINOR_VERSION@
+RAPPTURE_RELEASE_SERIAL=@RAPPTURE_RELEASE_SERIAL@
+RAPPTURE_VERSION="${RAPPTURE_MAJOR_VERSION}.${RAPPTURE_MINOR_VERSION}"
+SVN_VERSION="@SVN_VERSION@"
+
+WITH_R=@WITH_R@
+WITH_JAVA=@WITH_JAVA@
+WITH_MATLAB=@WITH_MATLAB@
+WITH_MKOCTFILE2=@WITH_MKOCTFILE2@
+WITH_MKOCTFILE3=@WITH_MKOCTFILE3@
+WITH_OCTAVE=@WITH_OCTAVE@
+WITH_PERL=@WITH_PERL@
+WITH_PYTHON=@WITH_PYTHON@
+WITH_RUBY=@WITH_RUBY@
+WITH_RUBY_SITELIBDIR=@WITH_RUBY_SITELIBDIR@
+WITH_TCL=@WITH_TCL@
+WITH_VTK=@WITH_VTK@
+